Bug 1410901 - Review Request: python-fmn - A system for generic fedmsg-driven notifications for end users
Summary: Review Request: python-fmn - A system for generic fedmsg-driven notification...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Randy Barlow
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-06 19:10 UTC by Jeremy Cline
Modified: 2017-07-06 14:02 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-07-06 14:02:36 UTC
Type: Bug
randy: fedora-review+


Attachments (Terms of Use)

Description Jeremy Cline 2017-01-06 19:10:16 UTC
Spec URL: https://jcline.fedorapeople.org/python-fmn.spec
SRPM URL: https://jcline.fedorapeople.org/python-fmn-1.0.0-1.fc25.src.rpm
Description:
fmn is a family of systems to manage end-user notifications triggered by
fedmsg, the FEDerated MESsage bus. fmn provides a single place for all
applications using fedmsg to notify users of events. Notifications can be
delivered by email, IRC, and server-sent events. Users can configure their
notifications for all the applications they use in one place.

Fedora Account System Username: jcline

Scratch build: https://koji.fedoraproject.org/koji/taskinfo?taskID=17181567

Note: This package merges the existing python-fmn-lib[0], python-fmn-rules[1], and python-fmn-consumer[2] packages. The spec file contains Obsoletes statements for all of these packages, but since this is not just a simple package rename I didn't include the Provides statements. Per the package renaming process[3], these packages can be retired after this is accepted.

[0] https://admin.fedoraproject.org/pkgdb/package/rpms/python-fmn-lib/
[1] https://admin.fedoraproject.org/pkgdb/package/rpms/python-fmn-rules/
[2] https://admin.fedoraproject.org/pkgdb/package/rpms/python-fmn-consumer/
[3] https://fedoraproject.org/wiki/Package_Renaming_Process

Comment 1 Randy Barlow 2017-01-19 18:36:06 UTC
A few things, some must some optional:

Must
====

* I think this package does Provide those packages it obsoletes and should be marked as such. For one, the "import fmn.whatever" statements will keep working, but for two the Fedora release upgrade path will be broken without it.


Should
======

* You should BuildRequires: python2-devel. I'm actually slightly surprised the build works without it…
* The cp command in the install section won't preserve the timestamp. You could use the -a flag to get cp to preserve it for you.
* I think fedora packages are supposed to use /usr/bin/python2 instead of /usr/bin/env python
* Does alembic.ini really need to be 640? It didn't appear to have secrets in it at first glance, and it's installed to /usr/share (which means users shouldn't be editing it anyway). It should probably be 644.


Optional
========

* I don't think you need to BuildRequires systemd. Is systemd-devel needed for the %{_unitdir} macro to exist?
* You could make the description be a global so you don't have to repeat it.
* It would be good to work on the upstream setup.py so that it installs the executable for you (so you don't have to do it manually in the install section).
* rpmlint wants irc to be capitalized.
* It would be good to write a manpage for fmn-createdb.


Also, fedora-review got mad that the spec URL and the SRPM don't match. I think it tested the spec inside the SRPM rather than the URL one.

Comment 2 Jeremy Cline 2017-01-23 16:45:03 UTC
Spec URL: https://jcline.fedorapeople.org/python-fmn.spec
SRPM URL: https://jcline.fedorapeople.org/python-fmn-1.1.0-1.fc25.src.rpm

(In reply to Randy Barlow from comment #1)
> A few things, some must some optional:
> 
> Must
> ====
> 
> * I think this package does Provide those packages it obsoletes and should
> be marked as such. For one, the "import fmn.whatever" statements will keep
> working, but for two the Fedora release upgrade path will be broken without
> it.

Thanks, I was not sure about this, but I think you're right. I've added the Provides statements.


> Should
> ======
> 
> * You should BuildRequires: python2-devel. I'm actually slightly surprised
> the build works without it…

Fixed.

> * The cp command in the install section won't preserve the timestamp. You
> could use the -a flag to get cp to preserve it for you.

Also fixed.

> * I think fedora packages are supposed to use /usr/bin/python2 instead of
> /usr/bin/env python

I changed upstream to generate the /usr/bin entry with setup.py

> * Does alembic.ini really need to be 640? It didn't appear to have secrets
> in it at first glance, and it's installed to /usr/share (which means users
> shouldn't be editing it anyway). It should probably be 644.

Nope, that's what I changed and I apparently forgot to rebuild the SRPM when I uploaded it.


> Optional
> ========
> 
> * I don't think you need to BuildRequires systemd. Is systemd-devel needed
> for the %{_unitdir} macro to exist?

The systemd package provides the macro, but I don't know why I thought I needed systemd-devel. I've removed that requirement.

> * You could make the description be a global so you don't have to repeat it.

I never remember how to make this work correctly so I just copy it :(

> * It would be good to work on the upstream setup.py so that it installs the
> executable for you (so you don't have to do it manually in the install
> section).

Done

> * rpmlint wants irc to be capitalized.

Done 

> * It would be good to write a manpage for fmn-createdb.

Issue filed: https://github.com/fedora-infra/fmn/issues/161

> Also, fedora-review got mad that the spec URL and the SRPM don't match. I
> think it tested the spec inside the SRPM rather than the URL one.

I've been really careful this time to not tweak the specfile without rebuilding the SRPM.

Comment 3 Randy Barlow 2017-01-25 13:45:59 UTC
I believe the Provides statements should be using the release, but even more importantly should be using the version macro. Otherwise, this package will always claim to provide the other packages at the versions they were retired at, which won't be true since it will be changing over time.

For example, instead of:

Provides: python-fmn-rules = 0.9.1

I think you need:

Provides: python-fmn-rules = %{version}-%{release}

You can read a bit about that here:

https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages

Here's an example spec file that uses a global for the description:

http://pkgs.fedoraproject.org/cgit/rpms/python-nose.git/tree/python-nose.spec

Comment 4 Jeremy Cline 2017-01-25 15:43:03 UTC
Spec URL: https://jcline.fedorapeople.org/python-fmn.spec
SRPM URL: https://jcline.fedorapeople.org/python-fmn-1.1.0-1.fc25.src.rpm

I updated the Provides. I don't know why I forgot about the release, but originally I couldn't use the version macro because I (somewhat arbitrarily) versioned the combined package at 1.0.0 since some of the old packages were 0.x.z and one was at 1.0.3. In hindsight this was bad, since the library suddenly dropped in version (and this is what made me hesitant to claim to provide it), but I've since bumped (somewhat arbitrarily) the version to 1.1.0 so everything is okay.

Comment 5 Randy Barlow 2017-01-30 11:57:09 UTC
Hmm, the build seems to fail in the %check section now:

  boole.localdomain  rbarlow  ~  reviews  tail -n 32 1410901-python-fmn/results/build.log
Traceback (most recent call last):
  File "/usr/lib64/python2.7/unittest/loader.py", line 254, in _find_tests
    module = self._get_module_from_name(name)
  File "/usr/lib64/python2.7/unittest/loader.py", line 232, in _get_module_from_name
    __import__(name)
ImportError: No module named tests.test_sse_backend
======================================================================
ERROR: fmn.tests.test_style (unittest.loader.ModuleImportFailure)
----------------------------------------------------------------------
ImportError: Failed to import test module: fmn.tests.test_style
Traceback (most recent call last):
  File "/usr/lib64/python2.7/unittest/loader.py", line 254, in _find_tests
    module = self._get_module_from_name(name)
  File "/usr/lib64/python2.7/unittest/loader.py", line 232, in _get_module_from_name
    __import__(name)
ImportError: No module named tests.test_style
----------------------------------------------------------------------
Ran 8 tests in 0.000s
FAILED (errors=8)
RPM build errors:
error: Bad exit status from /var/tmp/rpm-tmp.0AlpfW (%check)
    Bad exit status from /var/tmp/rpm-tmp.0AlpfW (%check)
Child return code was: 1
EXCEPTION: [Error()]
Traceback (most recent call last):
  File "/usr/lib/python3.6/site-packages/mockbuild/trace_decorator.py", line 89, in trace
    result = func(*args, **kw)
  File "/usr/lib/python3.6/site-packages/mockbuild/util.py", line 578, in do
    raise exception.Error("Command failed. See logs for output.\n # %s" % (command,), child.returncode)
mockbuild.exception.Error: Command failed. See logs for output.
 # bash --login -c /usr/bin/rpmbuild -bb --target x86_64 --nodeps /builddir/build/SPECS/python-fmn.spec
Mock Version: 1.3.3

Comment 6 Jeremy Cline 2017-01-30 14:41:58 UTC
Huh, I'm not able to reproduce that locally or in Koji: https://koji.fedoraproject.org/koji/taskinfo?taskID=17504533 - maybe you need to clean your mock root?

If I recall correctly, that traceback typically happens when the tests import a dependency that isn't available. The unittest loader doesn't provide a very helpful error.

Comment 7 Randy Barlow 2017-02-02 16:04:22 UTC
Weird, when I re-ran it, it worked. Passed!

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "LGPL (v2.1 or later)", "LGPL (v2.0 or later)", "*No copyright*
     GPL (v2 or later)", "Unknown or generated". 133 files have unknown
     license. Detailed output of licensecheck in
     /home/rbarlow/reviews/1410901-python-fmn/licensecheck.txt
[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/python2.7/site-
     packages/fmn/lib(python-fmn-lib), /usr/lib/python2.7/site-
     packages/fmn/consumer/backends(python-fmn-consumer),
     /usr/lib/python2.7/site-packages/fmn/rules(python-fmn-rules),
     /usr/lib/python2.7/site-packages/fmn(python-fmn-rules),
     /usr/lib/python2.7/site-packages/fmn/consumer(python-fmn-consumer)
     randy: This package is replacing these, so it's OK.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-fmn-1.1.0-1.fc26.noarch.rpm
          python-fmn-1.1.0-1.fc26.src.rpm
python2-fmn.noarch: W: no-manual-page-for-binary fmn-createdb
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
python2-fmn.noarch: W: no-manual-page-for-binary fmn-createdb
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
python2-fmn (rpmlib, GLIBC filtered):
    /usr/bin/python2
    fedmsg
    python(abi)
    python-arrow
    python-beautifulsoup4
    python-bleach
    python-docutils
    python-dogpile-cache
    python-fedmsg-meta-fedora-infrastructure
    python-fedora
    python-markupsafe
    python-moksha-hub
    python-pika
    python-redis
    python-requests
    python-six
    python-sqlalchemy
    systemd



Provides
--------
python2-fmn:
    python-fmn
    python-fmn-consumer
    python-fmn-lib
    python-fmn-rules
    python2-fmn
    python2.7dist(fmn)
    python2dist(fmn)



Source checksums
----------------
https://github.com/fedora-infra/fmn/archive/1.1.0/fmn-1.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 1479ef7451ae11660efc968aab0cca3e4b5c08b135b257608be171e15b962aad
  CHECKSUM(SHA256) upstream package : 1479ef7451ae11660efc968aab0cca3e4b5c08b135b257608be171e15b962aad


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1410901
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 8 Gwyn Ciesla 2017-02-02 17:14:46 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-fmn

Comment 9 Fedora Update System 2017-02-02 17:35:42 UTC
python-fmn-1.1.0-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-5c96fc62ac

Comment 10 Fedora Update System 2017-02-02 17:41:02 UTC
python-fmn-1.1.0-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-82cca28be0

Comment 11 Fedora Update System 2017-02-02 18:24:55 UTC
python-fmn-1.1.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0919f05ff5

Comment 12 Fedora Update System 2017-02-03 22:54:45 UTC
python-fmn-1.1.0-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-82cca28be0

Comment 13 Fedora Update System 2017-02-03 23:49:52 UTC
python-fmn-1.1.0-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-5c96fc62ac

Comment 14 Fedora Update System 2017-02-04 01:20:16 UTC
python-fmn-1.1.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0919f05ff5

Comment 15 Fedora Update System 2017-02-15 20:51:05 UTC
python-fmn-1.1.0-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 16 Fedora Update System 2017-02-15 20:53:18 UTC
python-fmn-1.1.0-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2017-05-31 18:30:55 UTC
python-fmn-1.3.0-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0919f05ff5

Comment 18 Fedora Update System 2017-06-01 14:28:16 UTC
python-fmn-1.3.0-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-0919f05ff5


Note You need to log in before you can comment on or make changes to this bug.